#
# LECA Bash library
#
# The LECA bash library provides a set of function used for helping
# development of bash script mainly to write job script on the luke
# cluster
#
# The files from the LECA Bash library must be sourced from your main script
#

include logging
logdebug "Load XML package"

include stacks


######
#
# XML formating function
#

newstack __LECABASH__markup__

function __LECABASH__XML_pad__() {
	local pad=$(printf '%0.1s' " "{1..60})
	local padlength=$(( $1 * 2 ))
	
	printf '%*.*s' 0 "$padlength" "$pad"
	
}

function XML_header() {

	echo '<?xml version="1.0" encoding="UTF-8"?>'

}

function XML_push() {

	local tag=$1
	shift
	local attribs="$*"
	__LECABASH__XML_pad__ $(stacksize __LECABASH__markup__)
	echo -n "<${tag}"
	if [[ -z "${attribs}" ]] ; then
		echo ">"
	else
		echo " ${attribs}>"
	fi
	pushvalue __LECABASH__markup__ "${tag}"
	
}

function XML_pop() {
	local tag=""
	popvalue __LECABASH__markup__ tag

	__LECABASH__XML_pad__ $(stacksize __LECABASH__markup__)
	echo   "</${tag}>"

}

function XML_tag_data() {

	local tag=$1
	shift
	__LECABASH__XML_pad__ $(stacksize __LECABASH__markup__)
	echo   "<${tag}>$*</${tag}>"

}

function XML_data() {

	__LECABASH__XML_pad__ $(stacksize __LECABASH__markup__)
	echo   "$*"

}

